unit MainUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.StdCtrls, Vcl.ComCtrls,System.RegularExpressions,VCL.Clipbrd;

type
  TMainFrm = class(TForm)
    IPList: TMemo;
    ChaXun: TButton;
    StatusBar1: TStatusBar;
    TuiChu: TButton;
    ZhanTie: TButton;
    Label1: TLabel;
    ShuangJIZhanTie: TCheckBox;
    Label2: TLabel;
    FenGeFu: TComboBox;
    FuZhi: TButton;
    procedure ChaXunClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TuiChuClick(Sender: TObject);
    procedure IPListDblClick(Sender: TObject);
    procedure ZhanTieClick(Sender: TObject);
    procedure FuZhiClick(Sender: TObject);
  private
    procedure GetIPInfo;
    procedure PasteClipboardToIPList;
    function CheckIPList:boolean;
    function YuChuLi:boolean;
                { Private declarations }
  public
                { Public declarations }
  end;

var
  MainFrm: TMainFrm;

implementation

{$R *.dfm}

uses
  IPLocationUnit;

var
  ipinfo: TIPLocation;
  kaishichaxun: Int64;
  jieshuchaxun: Int64;

function IsIPAddress(const IP: string): Boolean;
var
  regex: TRegex;
begin
  regex := TRegex.Create('^\b(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b$');
  Result := regex.IsMatch(IP);
end;

procedure TMainFrm.PasteClipboardToIPList;
var
  ClipboardText: string;
begin
  if Clipboard.HasFormat(CF_TEXT) then
  begin
    ClipboardText := Clipboard.AsText;
    IPList.Text := ClipboardText;
  end;
end;

procedure TMainFrm.GetIPInfo;
var
  s: string;
begin
  s := Format('·%s  ļС%.2fMB  ¼%d  ѯʱ䣺%d', [ipinfo.GetQQWryFileName, ipinfo.GetQQWryFileSize / (1024 * 1024), ipinfo.GetIPRecordNum, jieshuchaxun - kaishichaxun]);
  self.StatusBar1.Panels[1].Text := s;
end;

procedure TMainFrm.IPListDblClick(Sender: TObject);
begin
  if ShuangJIZhanTie.Checked then  PasteClipboardToIPList;
end;

procedure TMainFrm.TuiChuClick(Sender: TObject);
begin
  Close;
end;

function TMainFrm.YuChuLi:boolean;
var
  i:Integer;
  tmp:string;
  fenge:string;
begin
  tmp := IPList.Text;
  Result := True;
  case FenGeFu.ItemIndex of
    0:fenge := ' ';
    1:fenge := ',';
  end;
  IPList.Lines.Text := StringReplace(IPList.Lines.Text, fenge, Chr(13), [rfReplaceAll]);
  for i := 0 to IPList.Lines.Count - 1 do
  begin
    if Trim(IPList.Lines.Strings[i]) = '' then
    begin
      IPList.Lines.Delete(i);
    end;
  end;
  if not CheckIPList then
  begin
    IPList.Text := tmp;
    Result := False;
  end;
end;

procedure TMainFrm.ZhanTieClick(Sender: TObject);
begin
  PasteClipboardToIPList;
end;

procedure TMainFrm.ChaXunClick(Sender: TObject);
var
  i, a: Integer;
  tmp: TStringList;
  s: string;
begin
  kaishichaxun := GetTickCount;
  tmp := TStringList.Create;
  if not YuChuLi then Exit;
  for i := 0 to IPList.Lines.Count - 1 do
  begin
    s := '';
    if Trim(IPList.Lines.Strings[i]) = '' then
      Continue;
    for a := 0 to 15 - Length(Trim(IPList.Lines.Strings[i])) - 1 do
    begin
      s := s + ' ';
    end;
    tmp.Add(Format('[%s%s] => %s', [IPList.Lines.Strings[i], s, ipinfo.GetLocation(Trim(IPList.Lines.Strings[i]))]));
  end;
  jieshuchaxun := GetTickCount;
  GetIPInfo;
  IPList.Lines.Text := tmp.Text;
  tmp.Free;
end;

function TMainFrm.CheckIPList:boolean;
var
  i:Integer;
begin
  Result := True;
  for I := 0 to IPList.Lines.Count - 1 do
  begin
    if not IsIPAddress(Trim(IPList.Lines.Strings[i])) then
    begin
      Result := False;
      Break;
    end;
  end;
end;

procedure TMainFrm.FormCreate(Sender: TObject);
begin
  ipinfo := TIPLocation.Create('qqwry.dat');
  GetIPInfo;
end;

procedure TMainFrm.FuZhiClick(Sender: TObject);
begin
  IPList.SelectAll;
  Clipboard.SetTextBuf(PChar(IPList.Text));
end;

end.

